/*
 * Copyright (c) 2018 Zhang Hai <Dreaming.in.Code.ZH@Gmail.com>
 * All Rights Reserved.
 */

package me.zhanghai.android.files.glide;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.net.Uri;

import com.bumptech.glide.Glide;
import com.bumptech.glide.Registry;
import com.bumptech.glide.annotation.GlideModule;

import java.io.File;
import java.nio.ByteBuffer;

import androidx.annotation.NonNull;

@GlideModule
public class AppGlideModule extends com.bumptech.glide.module.AppGlideModule {

    @Override
    public boolean isManifestParsingEnabled() {
        return false;
    }

    @Override
    public void registerComponents(@NonNull Context context, @NonNull Glide glide,
                                   @NonNull Registry registry) {
        registry.prepend(String.class, ByteBuffer.class,
                new MediaEmbeddedPictureModelLoader.Factory<>());
        registry.prepend(File.class, ByteBuffer.class,
                new MediaEmbeddedPictureModelLoader.Factory<>());
        registry.prepend(Uri.class, ByteBuffer.class,
                new MediaEmbeddedPictureModelLoader.Factory<>());
        registry.prepend(String.class, Drawable.class, new ApkIconModelLoader.Factory<>(context));
        registry.prepend(File.class, Drawable.class, new ApkIconModelLoader.Factory<>(context));
        registry.prepend(Uri.class, Drawable.class, new ApkIconModelLoader.Factory<>(context));
    }
}
